var fs = require('fs')
var getFile = require('./util')
class FileListPlugin {
  constructor (options) {
    this.options = options
    if (!this.options.baseUrl) {
      throw new Error('[File-List-PLugin] baseUrl is need!')
    }
  }
  apply (compiler) {
    var { baseUrl, env } = this.options
    if (compiler.plugin) {
      compiler.plugin('emit', function (compilation, callback) {
        var source = compilation.assets['index.html'].source()
        handleIndexHTML(source, baseUrl, env)
        callback()
      })
    }else {
      compiler.hooks.emit.tapAsync('FileListPlugin', (compilation, callback) => {

        var source = compilation.assets['index.html'].source()
        handleIndexHTML(source, baseUrl, env)
        callback()
      })
    }
  }
}
function handleIndexHTML (source, baseUrl, env) {
  var filelist = getFile(source, baseUrl)
  env = env || process.env.NODE_ENV;

  fs.writeFileSync('files_' + env + '.json', JSON.stringify(filelist))
}
module.exports = FileListPlugin


