var cheerio = require('cheerio')
function getFiles (source, baseUrl) {
  var $ = cheerio.load(source)

  var staticFile = []
  var tagMap = {
    link: true,
    script: true
  }
  var files = []

  function handleNode (item) {
    // console.log(item.name)
    for (let key in item.attribs) {
      if (/^((href)|(src))$/.test(key)) {
        if (!/(http:\/\/|https:\/\/)((\w|=|\?|\.|\/|&|-)+)/g.test(item.attribs[key])) {
          item.attribs[key] = baseUrl + item.attribs[key]
        } 
      }
    }
    if (tagMap[item.name] && item.attribs.rel !== "icon") {
      files.push({
        type: item.name,
        attrs: item.attribs
      })
    // console.log(item.attribs)
    }
  }
  Array.from($('head').children()).forEach((item) => {
    handleNode(item)
  })

  Array.from($('body').children()).forEach((item) => {
    handleNode(item)
  })

  console.log(staticFile)
  return files;
}
module.exports = getFiles;
